package web;

import index.Indexer;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FSDataOutputStream;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;

public class Upload extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@SuppressWarnings("unchecked")
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {

		DiskFileItemFactory fileItemFactory = new DiskFileItemFactory();
		fileItemFactory.setSizeThreshold(100 * 1024 * 1024);
		fileItemFactory.setRepository(new File(getServletContext().getRealPath(
				"/Temp")));

		ServletFileUpload uploadHandler = new ServletFileUpload(fileItemFactory);

		try {
			List<FileItem> items = uploadHandler.parseRequest(request);

			for (FileItem item : items) {
				if (item.isFormField()) {

				} else {
					File file = new File(getServletContext().getRealPath(
							"/Temp"), item.getName());
					item.write(file);
					unzip(file);
				}
			}
		} catch (FileUploadException ex) {
			log("Error encountered while parsing the request", ex);
		} catch (Exception ex) {
			log("Error encountered while uploading file", ex);
		}

		Indexer.run();
	}

	private void unzip(File zip) throws IOException {
		FileSystem hdfs = FileSystem.get(new Configuration());
		final int BUFFER = 1024;
		String destinationPath = "Files";
		FileInputStream fis = null;
		fis = new FileInputStream(zip);
		ZipInputStream zis = new ZipInputStream(new BufferedInputStream(fis));
		BufferedOutputStream dest = null;
		ZipEntry entry;
		while ((entry = zis.getNextEntry()) != null) {
			System.out.println("Extracting: " + entry);
			int count;
			byte data[] = new byte[BUFFER];
			Path path = new Path(destinationPath + "/" + entry.getName());
			if (entry.isDirectory()) {
				continue;
			}
			FSDataOutputStream fsdos = null;
			try {
				fsdos = hdfs.create(path);
			} catch (IllegalArgumentException e) {
				fsdos = hdfs.create(new Path("Files/"
						+ Long.toHexString(Double.doubleToLongBits(Math
								.random()))));
			}
			dest = new BufferedOutputStream(fsdos, BUFFER);
			try {
				while ((count = zis.read(data, 0, BUFFER)) != -1) {
					dest.write(data, 0, count);
				}
			} catch (IOException e) {
				//continue
			}
			dest.flush();
			dest.close();
			fis.close();
		}
		zis.close();
	}

}
